
#include "SVector.h"
#include "Object.h"
#include "Enumeration.h"

#define stdinc 25

SVector::SVector()
{
  incrementSize = stdinc;
  elementCount = incrementSize;
  elementData = 0;
  vec = new (Object *)[incrementSize];
}

SVector::SVector(int _num)
{
  incrementSize = stdinc;
  elementCount = _num;
  elementData = 0;
  vec = new (Object *)[_num];
}

SVector::SVector(int _num, int _inc)
{
  incrementSize = _inc;
  elementCount  = _num;
  elementData = 0;
  vec = new (Object *)[_num];
}

SVector::SVector(SVector &_cvec)
{
  incrementSize = _cvec.getIncrementSize();
  elementCount = _cvec.getElementCount();
  elementData = _cvec.size();
  vec= new (Object *)[elementCount];
  for (int i=1; i<=elementData; i++)
    {
      vec[i]=(_cvec.elementAt(i))->clone();
    }
}

SVector::~SVector()
{
  while (elementData)
    {
      delete vec[elementData];
      --elementData;
    }
  delete vec;
}
      
void SVector::addElement(Object *_last)
{
  Object *member = _last->clone();
  if (elementData == (elementCount-1)) resize();
  ++elementData;
  vec[elementData] = member;
}

void SVector::insertElementAt(Object *_mid, int _where)

{
  if (_where <= elementData)
    {
      Object *member = _mid->clone();
      if (elementData == (elementCount-1)) resize();
      for (int i=elementData; i>=_where; i--)
	{
	  vec[i+1] = vec[i];
	}
      ++elementData;
      vec[_where] = member;
    }
  else 
    {
      addElement(_mid);
    }
}

void SVector::setElementAt(Object *_mid, int _where)
{
  if (_where<=elementData)
    {
      Object *member = _mid->clone();
      delete vec[_where];
      vec[_where]=member;
    }
  else ; //Exeption werfen
}

bool SVector::removeElementAt(int _where)
{
  if (_where<=elementData)
    {
      delete vec[_where];
      --elementData;
      for (int i = _where; i<=elementData; i++)
	{
	  vec[i] = vec[i+1];
	}
      if ((elementCount-elementData) > incrementSize) trim();
      return true;
    }
  else return false;
}

SVector *SVector::clone()
{
  SVector *clone = new SVector(*this);
  return clone;
}

String SVector::toString()
{
  String vectext;
  for (int i=1; i < elementData; i++)
    {
      vectext += vec[i]->toString();
    }
  vectext += vec[elementData]->toString() + "\n";
  return vectext;
}


ostream & operator<<(ostream &os,SVector &obj)
{
  os << obj.toString(); 
  return os;
}

